%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Created_Field_ID = DB_Field_Create(Dim)

global ErrCode;

global DB_FIELDS;
global AT_FIELDS;

global db_Next_Field_Number;

global AT_Page_Prealloc_Size;

Created_Field_ID = [];

% Проверка существования в базе поля со следующим номером
if (DB_Field_Exist(db_Next_Field_Number))
    fprintf (1, '\nОшибка функции DB_Field_Create: поле с номером %i уже существует в базе !\n', db_Next_Field_Number);
    ErrCode = -1;
    return;
end

% Проверка параметра Dim
if (isempty(Dim))
    fprintf (1, '\nОшибка функции DB_Field_Create: пустой параметр Dim !\n');
    ErrCode = -1;
    return;
end
if (Dim <=0)
    fprintf (1, '\nОшибка функции DB_Field_Create: недопустимое значение параметра Dim !\n');
    ErrCode = -1;
    return;
end

% Выделение памяти
if (isempty(DB_FIELDS))
    AT_FIELDS = zeros(AT_Page_Prealloc_Size,1,'uint64');
end
if (db_Next_Field_Number >= size(AT_FIELDS,1))
    AT_FIELDS(db_Next_Field_Number + AT_Page_Prealloc_Size,1) = 0;
end

% Следующий индекс в базе
Next_DB_index = size(DB_FIELDS,1) + 1;

% Создание записи в базе
DB_FIELDS{Next_DB_index,1}.ID = db_Next_Field_Number;
DB_FIELDS{Next_DB_index,1}.Dim = Dim;
DB_FIELDS{Next_DB_index,1}.Default = [];
DB_FIELDS{Next_DB_index,1}.AT = [];
DB_FIELDS{Next_DB_index,1}.ID_data = [];
DB_FIELDS{Next_DB_index,1}.Value_data = [];

% Создание ссылки в адресной таблице
AT_FIELDS(db_Next_Field_Number) = Next_DB_index;

% Номер созданного поля
Created_Field_ID = db_Next_Field_Number;

% Обновление счетчика
db_Next_Field_Number = db_Next_Field_Number + 1;
